---
# Get a tag from the repository.

- name: Get the tag for the current commit
  block:

    # If no tags are available, this command fails.
    - name: Attempt to get the current tag
      command: git describe --tags --exact-match HEAD
      args:
        chdir: "{{ workdir }}"
        warn: no
      register: git_describe

    - name: Set a fact for the raw tag from git
      set_fact:
        git_tag_raw: "{{ git_describe.stdout }}"

    - name: Print tag that was found
      debug:
        var: git_tag_raw

  rescue:

    # If the `git describe` failed, we generate our own tag here based on the
    # commit SHA.
    - name: Get the SHA of the current commit
      command: git rev-parse --short HEAD
      args:
        chdir: "{{ workdir }}"
        warn: no
      register: git_revlist

    - name: Set the tag using the short SHA
      set_fact:
        git_tag: "-{{ git_revlist.stdout }}"

- name: Set the tag if it matches kernel-VERSION-RELEASE format
  set_fact:
    git_tag: "-{{ git_describe.stdout.split('-') | last }}"
  when:
    - git_describe is success
    - git_tag_raw is search("^kernel-")

- name: Set the tag if it matches VERSION-RELEASE format
  set_fact:
    git_tag: "-{{ git_describe.stdout.split('-') | last }}"
  when:
    - git_describe is success
    - git_tag_raw is search("^[0-9]")
